%% This file is used to calibrate the model in Rubio and Yao 
%  
clear

global M_ oo_

modnam = 'ico';
modnamstar = 'ico_zlb';

constraint = 'r<1 - RSS';
constraint_relax = 'r>1 - RSS';

% Pick innovation for IRFs
irfshock =char('eps_d', 'eps_u');      % demand shock and prod. shock,

maxiter = 50;
tol0 = 1e-8;

nperiods = 1000;
% For simulation
SHOCKS  = zeros(nperiods,2); 

% do simulation
SHOCKS(:,1) = randn(nperiods,1) * 0.003;  % demand shock
SHOCKS(:,2) = randn(nperiods,1) * 0.007;  % productivity shock

shockssequence = SHOCKS;

% 2% SS interest rate
BETA = 0.995;
BETATILDE = 0.985;

phib = 0;
phiy = 0;
save parameterfile.mat phib phiy BETA BETATILDE;

% Solve model, generate model IRFs
[zdatalinear zdatapiecewise zdatass violvecbool_ oobase_ Mbase_  ] = ...
  solve_one_constraint(modnam,modnamstar,...
  constraint, constraint_relax,...
  shockssequence,irfshock,nperiods);


% unpack the IRFs                          
for i=1:M_.endo_nbr
  eval([deblank(M_.endo_names(i,:)),'_u=zdatalinear(:,i);']);
  eval([deblank(M_.endo_names(i,:)),'_p=zdatapiecewise(:,i);']);
  eval([deblank(M_.endo_names(i,:)),'_ss=zdatass(i);']);
end


% Plot
st = 1;    % start period of plotting
ed = 1000; % end period of plotting
TT = size(r_p(st:ed),1);
figure()

plot((r_p(st:ed)+(RSS-1))*400,'k','LineWidth', 1.)
hold on
%plot(regime(st:ed),'b','LineWidth', 1.)
plot( zeros(TT+1,1),'-k','LineWidth', 1);
title('Policy rate')
ylabel('Annualized Level, PPt')
xlim([0,TT])