//% New file of the simpleyou Iacoviello model

global DO_IRFS DO_ESTIMATION DO_HISTORICAL DO_GMM
global logxxx zz xxx irfs_mat EPSILON no_irfs_plot



//% DECLARE VARIABLES

var y x cu cc c hu hc lu  lc wu wc  bc r r_not dp q a_a r_e kt rr d lambda;  


//% THE GUYS BELOW ARE THE IID OF THE SHOCKS

varexo  eps_u eps_e eps_d;



//% PARAMETERS ENTER THE MODEL EQUATIONS


parameters BETATILDE, BETA, J, ETA, K, GAMMA, OMEGA, ALPHA, XSS, KTILDE, RHO, PHIP, PHIY, TECH phib phiy; 
parameters C_H B_C PHI CC_Y CU_Y QHC_Y QHU_Y RSS TAU_h Q;

//%------------------------------------------------------------
//% Model equations
//%------------------------------------------------------------

model;

%----------------------------   4.1 Patient Household   ------------------------------

//% eq 1
cu(+1) - cu = r - dp(+1) +d ;

//% eq 2
wu = (ETA)*lu + cu ;

//% eq 6
wc = (ETA)*lc + cc ;

//% eq 3
//hu = (1/(1-BETA))*(cu-q) - (BETA/(1-BETA))*(cu(+1)-q(+1)) ;
J*C_H*(cu - hu) = Q*q - BETA*Q*(q(+1) + cu - cu(+1));

//% eq 5
//bc = kt + q(+1) + hc + dp(+1) - r(+1);
bc = kt + q(+1) + hc + dp(+1) - r;

//% eq 4
//cc = ((PHI+J*K*(1-BETA))/PHI)*(y - x) - J/PHI*(hc-hc(-1))  + (K*J/PHI)*(BETA*bc - bc(-1))  - (K*J)*(r(-1)-dp) ;
cc + RSS*B_C*(r(-1) + bc(-1) - dp ) + (Q/C_H)*(hc-hc(-1)) = B_C*bc + (1-GAMMA)*(wc + lc);

//% eq 7
//hc = ((1-K*BETA)/PHI)*cc - (1/PHI)*q + (K*BETA/PHI)*( kt - r + dp(+1)) + ((BETATILDE/PHI)+(K/PHI)*(BETA-BETATILDE))*q(+1)  - (BETATILDE*(1-K)/PHI)*cc(+1) - (BETATILDE*K/PHI)*kt;
J*C_H*(cc - hc) = Q*q - BETATILDE*Q*(cc - cc(+1) + q(+1)) - (BETA - BETATILDE)*K*Q*(lambda + kt +  q(+1) + dp(+1) + cc);

0 = BETA*(lambda + r + cc) - BETATILDE*(dp(+1) + lambda + cc(+1) );

//% eq 8
c =  OMEGA*cu + (1 - OMEGA)*cc;

//% eq 10
0 = OMEGA*hu + (1 - OMEGA)*hc ;

//% eq 11
y = a_a + GAMMA*lu + (1-GAMMA)*lc ;

//% eq 12
wu =  y - x - lu ;

//% eq 13
wc =  y - x - lc ;

//% eq 14
dp = BETA*dp(+1) - KTILDE*x ;

//% eq 15
r_not = RHO*r_not(-1) + (1-RHO)*(1+PHIP)*dp + (1-RHO)*PHIY*(y-y(-1)) + r_e   ;

r = 1 -  RSS ;

rr = r - dp(+1);

//% eq 16
y = c ;

a_a=TECH*a_a(-1)+eps_u;

r_e=0.0*r_e(-1)+eps_e;

kt= -phib*bc - phiy*y;

d = 0.8*d(-1) + eps_d;

end ;

