%% set inputs for solution below
%  The program produces responses to the shocks selected below under
%  irfshock. Paths for all the endogenous variables in the model selected
%  are produced. VariableName_difference holds the piece-wise linear solution for
%  VariableName.  VariableName_uncdifference holds the linear solution for
%  VariableName.
clear all;

global M_ oo_


BETA = 0.99;
BETATILDE = 0.98; 


% 
% % phib
 xparams =0; %[0:0.01:0.6];% 
% % phiy
yparams = 0; %[0:0.01:0.6];% 

%(3) create the matrices of the values to be considered
[Xgrid,Ygrid] = meshgrid(xparams,yparams);
%Xgrid and Ygrid are the same size. They are maxcountery*maxcounterx


%(4) The number of x values to be considred
maxcounterx =size(xparams,2);

%(5) The number of y values to be considered
maxcountery = size(yparams,2);

nvar = 4; %number of simulated variables
nperiods = 1000; % number of simulation periods

maxcounter=length(xparams)*length(yparams);
 
outcounter = 1;


%stochmean = zeros(maxcountery,maxcounterx,nvar); %This saves the stochastic mean of the simulated series
stochvariance = zeros(); %This saves the stochastic variances of the simulated series
simuldata = cell(maxcountery,maxcounterx);
LOSS_zlb = zeros(maxcountery,maxcounterx);
counter = 1;
num_mx=1;
num_my = 1;

% policy weights

ETA = 1;
GAMMA = .64;
THITA = .75; % Calvo parameter
EPS = 6; % PRICE ELASTICITY

weight_dp = THITA*EPS/(1-THITA)/(1-BETA*THITA)/(1+ETA);
weight_c = GAMMA*(1-GAMMA)*(2+ETA)/(1+ETA)/(1+ETA);
weight_h = GAMMA*(1-GAMMA)/(1+ETA);

 for num_mx = 1:maxcounterx %loop over x first
     
     for num_my = 1:maxcountery %loop over y for a given x
         
         sprintf('Progress: %d/%d',counter,maxcounter) 
         
         phib = Xgrid(num_my,num_mx);
         phiy = Ygrid(num_my,num_mx);
         
         save parameterfile.mat phib phiy BETA BETATILDE;
                  
         % solve the model
         
    irfshock =char('eps_d', 'eps_u');      % label for demand shock IRFs'eps_d',

    maxiter = 200;
    tol0 = 1e-8;

    % For simulation
    SHOCKS  = zeros(nperiods,2); 

    % do simulation
    SHOCKS(:,1) = randn(nperiods,1) * 0.0015;  % demand shock
    SHOCKS(:,2) = randn(nperiods,1) * 0.007; % productivity shock
          
    shockssequence = SHOCKS;

        % models and constraints
         modnam = 'ico';
         modnamstar = 'ico_zlb';

         constraint = 'r<1 - RSS';
         constraint_relax ='r_not>1 - RSS';
        
        % Solve model, generate model IRFs
          [zdatalinear zdatapiecewise zdatass oobase_ Mbase_  ] = ...
          solve_one_constraint(modnam,modnamstar,...
          constraint, constraint_relax,...
          shockssequence,irfshock,nperiods);

        % unpack the data                          
          for i=1:M_.endo_nbr
            eval([deblank(M_.endo_names(i,:)),'_p=zdatapiecewise(:,i);']);
          end
         axa = [yg_p(101:end-100)  dp_p(101:end-100)  cg_p(101:end-100) hg_p(101:end-100)];
         axa = min(10,axa);
         axa = max(-10,axa);
         simuldata{num_my,num_mx} = axa; %x indexes the pages
                          
         stochvariance(num_my,num_mx,1) = var(axa(:,1));
         stochvariance(num_my,num_mx,2) = var(axa(:,2));
         stochvariance(num_my,num_mx,3) = var(axa(:,3));
         stochvariance(num_my,num_mx,4) = var(axa(:,4));
        
        LOSS_zlb(num_my,num_mx) = var(yg_p) + weight_dp* var(dp_p) + weight_c*var(cg_p) + weight_h*var(hg_p);
        
        counter = counter + 1;
     end
 end
 

 
% save occbinsimudatout_2_b LOSS_zlb stochvariance nvar simuldata xparams yparams%stochmean 
%save grids Xgrid Ygrid
    
% one dimension case

% figure() % Volatility
% 
% subplot(2,3,1)  
%     plot(Xgrid(1:maxcounterx),LOSS_zlb(1,1:maxcounterx),'-b','LineWidth', 2.0);
%         xlabel('Policy response','FontSize',12);
% %ylabel('\bf%','FontSize',12); 
%     title('Total Loss phib','FontSize',14,'FontWeight','bold');    
%     
% subplot(2,3,2)  
%     plot(Xgrid(1:maxcounterx),stochvariance(1,1:maxcounterx,1),'-b','LineWidth', 2.0);
%         xlabel('Policy response','FontSize',12);
%     title('Volatility of the output gap','FontSize',14,'FontWeight','bold');
%    % ylabel('\bf%','FontSize',12); 
%     %legend( 'Output','Credit');
%     %legend('Zeta = 0.5', 'Zeta = 1.5', '','FontSize',14);
%     %xlim([1 30])
%     %hold off
% subplot(2,3,3)  
%     plot(Xgrid(1:maxcounterx),stochvariance(1,1:maxcounterx,2),'-b','LineWidth', 2.0);
%         xlabel('Policy response','FontSize',12);
% ylabel('\bf%','FontSize',12); 
%     title('Volatility of infaltion gap','FontSize',14,'FontWeight','bold');
% subplot(2,3,4)  
%     plot(Xgrid(1:maxcounterx),stochvariance(1,1:maxcounterx,3),'-b','LineWidth', 2.0);
%         xlabel('Policy response','FontSize',12);
% %ylabel('\bf%','FontSize',12); 
%     title('Volatility of consumption gap','FontSize',14,'FontWeight','bold');    
% 
% subplot(2,3,5)  
%     plot(Xgrid(1:maxcounterx),stochvariance(1,1:maxcounterx,4),'-b','LineWidth', 2.0);
%         xlabel('Policy response','FontSize',12);
% %ylabel('\bf%','FontSize',12); 
%     title('Volatility of housing gap','FontSize',14,'FontWeight','bold');
% 
% 
[valmax, etapmax] = max(-0.5*LOSS_zlb)
 xparams(etapmax)
 var_yg = stochvariance(1,etapmax,1)*100
 var_dp = stochvariance(1,etapmax,2)*100
 var_cg = stochvariance(1,etapmax,3)*100    
 var_hg = stochvariance(1,etapmax,4)*100
% 
%  
% 2 dimension case

% figure()
% 

% LOSS_zlb = min(0.01,LOSS_zlb);
% 
% surf(Xgrid,Ygrid, -LOSS_zlb*100 );shading interp
% title('\bfLoss Function','FontSize',12)
% xlabel('Policy response to debt','FontSize',10);
% ylabel('Policy response to output','FontSize',10);
% % 
 [valmax, etapmax] =max(-LOSS_zlb');
 [valmaxmax,etaymax ] =max(valmax)
 phib = xparams(etapmax(etaymax))
 phiy = yparams(etaymax)
 var_yg = stochvariance(etaymax,etapmax(etaymax),1)*100
 var_dp = stochvariance(etaymax,etapmax(etaymax),2)*100
 var_cg = stochvariance(etaymax,etapmax(etaymax),3)*100    
 var_hg = stochvariance(etaymax,etapmax(etaymax),4)*100 
 
 BETA = 0.995;
BETATILDE = 0.985; 
 ETA = 1;
GAMMA = .64;
THITA = .75; % Calvo parameter
EPS = 6; % PRICE ELASTICITY
weight_dp = THITA*EPS/(1-THITA)/(1-BETA*THITA)/(1+ETA);
weight_c = GAMMA*(1-GAMMA)*(2+ETA)/(1+ETA)/(1+ETA);
weight_h = GAMMA*(1-GAMMA)/(1+ETA);
loss = -0.5*(  var_yg + weight_dp* var_dp + weight_c*var_cg + weight_h*var_hg)


%%  

% st = 1;    % start period of plotting
% ed = 1000; % end period of plotting
% TT = size(r_p(st:ed),1);
% figure()
% 
% subplot(2,2,1)
% plot((r_p(st:ed)+(RSS-1))*400,'k','LineWidth', 1.)
% hold on
% plot( zeros(TT+1,1),'-k','LineWidth', 1);
% title('Policy rate')
% ylabel('Annualized Level, PPt')
%  xlim([0,TT])
%  legend('2% S.S. interest rate','4% S.S. interest rate)')
%  
% subplot(2,2,2)
% plot( 100*y_p(st:ed),'k','LineWidth', 1.)
%  hold on
% 
%  plot( zeros(TT+1,1),'-k','LineWidth', 1);
%  title('\bfOutput','FontSize',12)
%  ylabel('\bf% from S.S.')
%  xlim([1,TT])
%  %ylim([0,3])
%  %csPatches(gcf,bindingdates)
%  
%  
% subplot(2,2,3)
%  plot( 100*q_p(st:ed),'k','LineWidth', 1.)
%  hold on
%  
%  plot( zeros(TT+1,1),'-k','LineWidth', 1);
%  title('\bfHouse Price','FontSize',12)
%  ylabel('\bf% from S.S.')
%  %csPatches(gcf,bindingdates)
%  xlim([0,TT]) 
%  
% subplot(2,2,4)
% plot( 100*bc_p(st:ed),'k','LineWidth', 1.)
%  hold on
%  
%  plot( zeros(TT+1,1),'-k','LineWidth', 1);
%  title('\bfDebt','FontSize',12)
%  ylabel('\bf% from S.S.')
%  xlim([1,TT])
%  %ylim([0,3])
%  %csPatches(gcf,bindingdates)
%  %legend('Occbin','no ZLB')
%  
